Index: c/src/lib/libbsp/unix/posix/console/console.c
===================================================================
--- c/src/lib/libbsp/unix/posix/console/console.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libbsp/unix/posix/console/console.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -3,4 +3,6 @@
  *
  *  These provide UNIX-like read and write calls for the C library.
+ *
+ *  NOTE:  For the most part, this is just a space holder.
  *
  *  COPYRIGHT (c) 1994 by Division Incorporated
@@ -32,5 +34,70 @@
 )
 {
-    return RTEMS_SUCCESSFUL;
+  return 0;
 }
 
+
+/*
+ *  Open entry point
+ */
+
+rtems_device_driver console_open(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
+ 
+/*
+ *  Close entry point
+ */
+
+rtems_device_driver console_close(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
+
+/*
+ * read bytes from the serial port. We only have stdin.
+ */
+
+rtems_device_driver console_read(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_UNSATISFIED;
+}
+
+/*
+ * write bytes to the serial port. Stdout and stderr are the same. 
+ */
+
+rtems_device_driver console_write(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return -1;
+}
+
+/*
+ *  IO Control entry point
+ */
+
+rtems_device_driver console_control(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
Index: c/src/lib/libbsp/unix/posix/include/bsp.h
===================================================================
--- c/src/lib/libbsp/unix/posix/include/bsp.h	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libbsp/unix/posix/include/bsp.h	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -23,4 +23,5 @@
 #include <rtems.h>
 #include <clockdrv.h>
+#include <console.h>
 #include <iosupp.h>
 #include <libcsupport.h>
@@ -81,12 +82,10 @@
 
 /*
- * Console driver init
+ *  Device Driver Table Entries
  */
- 
-rtems_device_driver console_initialize(
-  rtems_device_major_number, rtems_device_minor_number minor, void *);
- 
-#define CONSOLE_DRIVER_TABLE_ENTRY \
-  { console_initialize, NULL, NULL, NULL, NULL, NULL }
+
+/*
+ * NOTE: Use the standard Console driver entry
+ */
  
 /*
@@ -94,4 +93,10 @@
  */
  
+/*
+ * How many libio files we want
+ */
+
+#define BSP_LIBIO_MAX_FDS       20
+
 /* functions */
 
Index: c/src/lib/libbsp/unix/posix/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/unix/posix/startup/bspstart.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libbsp/unix/posix/startup/bspstart.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -37,4 +37,6 @@
 #include <bsp.h>
 #include <libcsupport.h>
+
+#include <rtems/libio.h>
 
 #ifdef STACK_CHECKER_ON
@@ -113,4 +115,12 @@
     RTEMS_Malloc_Initialize((void *)heap_start, Heap_size, 1024 * 1024);
 
+    /*
+     *  Init the RTEMS libio facility to provide UNIX-like system
+     *  calls for use by newlib (ie: provide __open, __close, etc)
+     *  Uses malloc() to get area for the iops, so must be after malloc init
+     */
+
+    rtems_libio_init();
+
     libc_init(1);
 }
@@ -159,4 +169,32 @@
 #ifdef RTEMS_DEBUG
     rtems_debug_enable( RTEMS_DEBUG_ALL_MASK );
+#endif
+}
+
+/*
+ * After drivers are setup, register some "filenames"
+ * and open stdin, stdout, stderr files
+ *
+ * Newlib will automatically associate the files with these
+ * (it hardcodes the numbers)
+ */
+ 
+void
+bsp_postdriver_hook(void)
+{
+#if 0
+  int stdin_fd, stdout_fd, stderr_fd;
+ 
+  if ((stdin_fd = __open("/dev/console", O_RDONLY, 0)) == -1)
+    rtems_fatal_error_occurred('STD0');
+ 
+  if ((stdout_fd = __open("/dev/console", O_WRONLY, 0)) == -1)
+    rtems_fatal_error_occurred('STD1');
+ 
+  if ((stderr_fd = __open("/dev/console", O_WRONLY, 0)) == -1)
+    rtems_fatal_error_occurred('STD2');
+ 
+  if ((stdin_fd != 0) || (stdout_fd != 1) || (stderr_fd != 2))
+    rtems_fatal_error_occurred('STIO');
 #endif
 }
@@ -262,5 +300,5 @@
     Cpu_table.predriver_hook = NULL;
 
-    Cpu_table.postdriver_hook = NULL;
+    Cpu_table.postdriver_hook = bsp_postdriver_hook;
 
     Cpu_table.idle_task = NULL;  /* do not override system IDLE task */
@@ -302,21 +340,27 @@
 #endif
 
-    /*
-     * Add 1 extension for MPCI_fatal
-     */
-
-    if (BSP_Configuration.User_multiprocessing_table)
-        BSP_Configuration.maximum_extensions++;
-
-    CPU_CLICKS_PER_TICK = 1;
-
-    /*
-     *  Start most of RTEMS
-     *  main() will start the rest
-     */
-
-    bsp_isr_level = rtems_initialize_executive_early(
-      &BSP_Configuration,
-      &Cpu_table
-    );
+  /*
+   * Tell libio how many fd's we want and allow it to tweak config
+   */
+
+  rtems_libio_config(&BSP_Configuration, BSP_LIBIO_MAX_FDS);
+
+  /*
+   * Add 1 extension for MPCI_fatal
+   */
+
+  if (BSP_Configuration.User_multiprocessing_table)
+      BSP_Configuration.maximum_extensions++;
+
+  CPU_CLICKS_PER_TICK = 1;
+
+  /*
+   *  Start most of RTEMS
+   *  main() will start the rest
+   */
+
+  bsp_isr_level = rtems_initialize_executive_early(
+    &BSP_Configuration,
+    &Cpu_table
+  );
 }
Index: c/src/lib/libc/error.c
===================================================================
--- c/src/lib/libc/error.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libc/error.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -92,6 +92,6 @@
     { "directive not implemented",          RTEMS_NOT_IMPLEMENTED, },
     { "RTEMS inconsistency detected",       RTEMS_INTERNAL_ERROR, },
-    { "internal multiprocessing only",      RTEMS_PROXY_BLOCKING, },
     { "could not get enough memory",        RTEMS_NO_MEMORY, },
+    { "internal multiprocessing only",      THREAD_STATUS_PROXY_BLOCKING, },
     { 0, 0, 0 },
 };
@@ -135,5 +135,5 @@
         local_errno = errno;
 
-    if (_Configuration_Is_multiprocessing())
+    if (_System_state_Is_multiprocessing)
         fprintf(stderr, "[%d] ", _Configuration_MP_table->node);
     
Index: c/src/lib/libc/libio.c
===================================================================
--- c/src/lib/libc/libio.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libc/libio.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -15,6 +15,9 @@
 
 #include <fcntl.h>                      /* O_RDONLY, et.al. */
+#include <sys/fcntl.h>                      /* O_RDONLY, et.al. */
 #if defined(solaris2)
 #define O_NDELAY O_NONBLOCK
+#elif  defined(RTEMS_NEWLIB)
+#define O_NDELAY _FNBIO
 #endif
 #include <errno.h>
Index: c/src/lib/libc/newlibc.c
===================================================================
--- c/src/lib/libc/newlibc.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libc/newlibc.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -81,9 +81,10 @@
 
 
-rtems_extension
+rtems_boolean
 libc_create_hook(rtems_tcb *current_task,
                  rtems_tcb *creating_task)
 {
     MY_task_set_note(creating_task, LIBC_NOTEPAD, 0);
+    return TRUE;
 }
 
@@ -232,8 +233,8 @@
         memset(&libc_extension, 0, sizeof(libc_extension));
 
-        libc_extension.rtems_task_create  = libc_create_hook;
-        libc_extension.rtems_task_start   = libc_start_hook;
-        libc_extension.task_switch  = libc_switch_hook;
-        libc_extension.rtems_task_delete  = libc_delete_hook;
+        libc_extension.thread_create  = libc_create_hook;
+        libc_extension.thread_start   = libc_start_hook;
+        libc_extension.thread_switch  = libc_switch_hook;
+        libc_extension.thread_delete  = libc_delete_hook;
 
         rc = rtems_extension_create(rtems_build_name('L', 'I', 'B', 'C'),
Index: c/src/lib/libc/support.c
===================================================================
--- c/src/lib/libc/support.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libc/support.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -14,6 +14,5 @@
  */
 
-#include <rtems/system.h>
-#include <rtems/thread.h>
+#include <rtems.h>
 
 void MY_task_set_note(
@@ -23,5 +22,9 @@
 )
 {
-  the_thread->RTEMS_API->Notepads[ notepad ] = note;
+  RTEMS_API_Control    *api;
+ 
+  api = the_thread->API_Extensions[ THREAD_API_RTEMS ];
+
+  api->Notepads[ notepad ] = note;
 }
 
@@ -32,5 +35,9 @@
 )
 {
-  return the_thread->RTEMS_API->Notepads[ notepad ];
+  RTEMS_API_Control    *api;
+ 
+  api = the_thread->API_Extensions[ THREAD_API_RTEMS ];
+
+  return api->Notepads[ notepad ];
 }
 
Index: c/src/lib/libcpu/powerpc/ppc403/clock/clock.c
===================================================================
--- c/src/lib/libcpu/powerpc/ppc403/clock/clock.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libcpu/powerpc/ppc403/clock/clock.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -34,4 +34,5 @@
 #include <bsp.h>
 #include <clockdrv.h>
+#include <rtems/libio.h>
 
 #include <stdlib.h>                     /* for atexit() */
@@ -43,30 +44,13 @@
 static rtems_boolean auto_restart;
 
-rtems_device_driver Clock_initialize(
-  rtems_device_major_number major,
-  rtems_device_minor_number minor,
-  void *pargp,
-  rtems_id tid,
-  rtems_unsigned32 *rval
-)
-{
-    Install_clock(Clock_isr);
-}
-
-
-void
-ReInstall_clock(rtems_isr_entry new_clock_isr)
-{
-    rtems_isr_entry previous_isr;
-    rtems_unsigned32 isrlevel = 0;
-
-    rtems_interrupt_disable(isrlevel);
-    
-    rtems_interrupt_catch(new_clock_isr, PPC_IRQ_PIT,
-			  &previous_isr);
-
-    rtems_interrupt_enable(isrlevel);
-}
-
+void Clock_exit( void );
+ 
+/*
+ * These are set by clock driver during its init
+ */
+ 
+rtems_device_major_number rtems_clock_major = ~0;
+rtems_device_minor_number rtems_clock_minor;
+ 
 static INLINE rtems_unsigned32 get_itimer(void)
 {
@@ -76,4 +60,67 @@
 
     return rc;
+}
+
+/*
+ *  ISR Handler
+ */
+ 
+rtems_isr
+Clock_isr(rtems_vector_number vector)
+{
+    if (!auto_restart)
+	{
+	    rtems_unsigned32 clicks_til_next_interrupt;
+	    rtems_unsigned32 itimer_value;
+
+	    /*
+	     * setup for next interrupt; making sure the new value is reasonably
+	     * in the future.... in case we lost out on an interrupt somehow
+	     */
+
+	    itimer_value = get_itimer();
+	    tick_time += pit_value;
+
+	    /*
+	     * how far away is next interrupt *really*
+	     * It may be a long time; this subtraction works even if
+	     * Clock_clicks_interrupt < Clock_clicks_low_order via
+	     * the miracle of unsigned math.
+	     */
+	    clicks_til_next_interrupt = tick_time - itimer_value;
+
+	    /*
+	     * If it is too soon then bump it up.
+	     * This should only happen if CPU_HPPA_CLICKS_PER_TICK is too small.
+	     * But setting it low is useful for debug, so...
+	     */
+
+	    if (clicks_til_next_interrupt < 400)
+		{
+		    tick_time = itimer_value + 1000;
+		    clicks_til_next_interrupt = 1000;
+		    /* XXX: count these! this should be rare */
+		}
+
+	    /*
+	     * If it is too late, that means we missed the interrupt somehow.
+	     * Rather than wait 35-50s for a wrap, we just fudge it here.
+	     */
+	    
+	    if (clicks_til_next_interrupt > pit_value)
+		{
+		    tick_time = itimer_value + 1000;
+		    clicks_til_next_interrupt = 1000;
+		    /* XXX: count these! this should never happen :-) */
+		}
+
+	    asm volatile ("mtpit %0" :: "r" (clicks_til_next_interrupt));
+	}
+
+    asm volatile ( "mttsr %0" :: "r" (0x08000000));
+
+    Clock_driver_ticks++;
+
+    rtems_clock_tick();
 }
 
@@ -132,63 +179,18 @@
 }
 
-
-rtems_isr
-Clock_isr(rtems_vector_number vector)
-{
-    if (!auto_restart)
-	{
-	    rtems_unsigned32 clicks_til_next_interrupt;
-	    rtems_unsigned32 itimer_value;
-
-	    /*
-	     * setup for next interrupt; making sure the new value is reasonably
-	     * in the future.... in case we lost out on an interrupt somehow
-	     */
-
-	    itimer_value = get_itimer();
-	    tick_time += pit_value;
-
-	    /*
-	     * how far away is next interrupt *really*
-	     * It may be a long time; this subtraction works even if
-	     * Clock_clicks_interrupt < Clock_clicks_low_order via
-	     * the miracle of unsigned math.
-	     */
-	    clicks_til_next_interrupt = tick_time - itimer_value;
-
-	    /*
-	     * If it is too soon then bump it up.
-	     * This should only happen if CPU_HPPA_CLICKS_PER_TICK is too small.
-	     * But setting it low is useful for debug, so...
-	     */
-
-	    if (clicks_til_next_interrupt < 400)
-		{
-		    tick_time = itimer_value + 1000;
-		    clicks_til_next_interrupt = 1000;
-		    /* XXX: count these! this should be rare */
-		}
-
-	    /*
-	     * If it is too late, that means we missed the interrupt somehow.
-	     * Rather than wait 35-50s for a wrap, we just fudge it here.
-	     */
-	    
-	    if (clicks_til_next_interrupt > pit_value)
-		{
-		    tick_time = itimer_value + 1000;
-		    clicks_til_next_interrupt = 1000;
-		    /* XXX: count these! this should never happen :-) */
-		}
-
-	    asm volatile ("mtpit %0" :: "r" (clicks_til_next_interrupt));
-	}
-
-    asm volatile ( "mttsr %0" :: "r" (0x08000000));
-
-    Clock_driver_ticks++;
-
-    rtems_clock_tick();
-}
+void
+ReInstall_clock(rtems_isr_entry new_clock_isr)
+{
+    rtems_isr_entry previous_isr;
+    rtems_unsigned32 isrlevel = 0;
+
+    rtems_interrupt_disable(isrlevel);
+    
+    rtems_interrupt_catch(new_clock_isr, PPC_IRQ_PIT,
+			  &previous_isr);
+
+    rtems_interrupt_enable(isrlevel);
+}
+
 
 /*
@@ -214,2 +216,49 @@
 }
 
+rtems_device_driver Clock_initialize(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void *pargp
+)
+{
+  Install_clock( Clock_isr );
+ 
+  /*
+   * make major/minor avail to others such as shared memory driver
+   */
+ 
+  rtems_clock_major = major;
+  rtems_clock_minor = minor;
+ 
+  return RTEMS_SUCCESSFUL;
+}
+ 
+rtems_device_driver Clock_control(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void *pargp
+)
+{
+    rtems_libio_ioctl_args_t *args = pargp;
+ 
+    if (args == 0)
+        goto done;
+ 
+    /*
+     * This is hokey, but until we get a defined interface
+     * to do this, it will just be this simple...
+     */
+ 
+    if (args->command == rtems_build_name('I', 'S', 'R', ' '))
+    {
+        Clock_isr(PPC_IRQ_PIT);
+    }
+    else if (args->command == rtems_build_name('N', 'E', 'W', ' '))
+    {
+        ReInstall_clock(args->buffer);
+    }
+ 
+done:
+    return RTEMS_SUCCESSFUL;
+}
+
Index: c/src/lib/libcpu/powerpc/ppc403/console/console.c
===================================================================
--- c/src/lib/libcpu/powerpc/ppc403/console/console.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libcpu/powerpc/ppc403/console/console.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -32,7 +32,6 @@
 #define NO_BSP_INIT
 
-#include <rtems.h>
-#include "console.h"
-#include "bsp.h"
+#include <bsp.h>
+#include <rtems/libio.h>
 
 extern rtems_cpu_table           Cpu_table;             /* owned by BSP */
@@ -140,9 +139,8 @@
   rtems_device_major_number  major,
   rtems_device_minor_number  minor,
-  void                      *arg,
-  rtems_id                   self,
-  rtems_unsigned32          *status
-)
-{
+  void                      *arg
+)
+{
+  rtems_status_code status;
   register unsigned tmp;
 
@@ -165,5 +163,14 @@
   port->SPHS = (HSRDsr | HSRCts);
 
-  *status = RTEMS_SUCCESSFUL;
+  status = rtems_io_register_name(
+    "/dev/console",
+    major,
+    (rtems_device_minor_number) 0
+  );
+ 
+  if (status != RTEMS_SUCCESSFUL)
+    rtems_fatal_error_occurred(status);
+ 
+  return RTEMS_SUCCESSFUL;
 }
 
@@ -281,47 +288,102 @@
 
 /*
- * __read  -- read bytes from the serial port. Ignore fd, since
- *            we only have stdin.
- */
-
-int __read(
-  int fd,
-  char *buf,
-  int nbytes
-)
-{
-  int i = 0;
-
-  for (i = 0; i < nbytes; i++) {
-    *(buf + i) = inbyte();
-    if ((*(buf + i) == '\n') || (*(buf + i) == '\r')) {
-      (*(buf + i++)) = '\n';
-      (*(buf + i)) = 0;
+ *  Open entry point
+ */
+ 
+rtems_device_driver console_open(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
+ 
+/*
+ *  Close entry point
+ */
+ 
+rtems_device_driver console_close(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
+ 
+/*
+ * read bytes from the serial port. We only have stdin.
+ */
+ 
+rtems_device_driver console_read(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  rtems_libio_rw_args_t *rw_args;
+  char *buffer;
+  int maximum;
+  int count = 0;
+ 
+  rw_args = (rtems_libio_rw_args_t *) arg;
+ 
+  buffer = rw_args->buffer;
+  maximum = rw_args->count;
+ 
+  for (count = 0; count < maximum; count++) {
+    buffer[ count ] = inbyte();
+    if (buffer[ count ] == '\n' || buffer[ count ] == '\r') {
+      buffer[ count++ ]  = '\n';
+      buffer[ count ]  = 0;
       break;
     }
   }
-  return (i);
-}
-
-/*
- * __write -- write bytes to the serial port. Ignore fd, since
- *            stdout and stderr are the same. Since we have no filesystem,
- *            open will only return an error.
- */
-
-int __write(
-  int fd,
-  char *buf,
-  int nbytes
-)
-{
-  int i;
-
-  for (i = 0; i < nbytes; i++) {
-    if (*(buf + i) == '\n') {
-      outbyte ('\r');
-    }
-    outbyte (*(buf + i));
+ 
+  rw_args->bytes_moved = count;
+  return (count >= 0) ? RTEMS_SUCCESSFUL : RTEMS_UNSATISFIED;
+}
+ 
+/*
+ * write bytes to the serial port. Stdout and stderr are the same.
+ */
+ 
+rtems_device_driver console_write(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  int count;
+  int maximum;
+  rtems_libio_rw_args_t *rw_args;
+  char *buffer;
+ 
+  rw_args = (rtems_libio_rw_args_t *) arg;
+ 
+  buffer = rw_args->buffer;
+  maximum = rw_args->count;
+ 
+  for (count = 0; count < maximum; count++) {
+    if ( buffer[ count ] == '\n') {
+      outbyte('\r');
+    }
+    outbyte( buffer[ count ] );
   }
-  return (nbytes);
-}
+  return maximum;
+}
+ 
+/*
+ *  IO Control entry point
+ */
+ 
+rtems_device_driver console_control(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
+
Index: c/src/lib/libmisc/error/error.c
===================================================================
--- c/src/lib/libmisc/error/error.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libmisc/error/error.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -92,6 +92,6 @@
     { "directive not implemented",          RTEMS_NOT_IMPLEMENTED, },
     { "RTEMS inconsistency detected",       RTEMS_INTERNAL_ERROR, },
-    { "internal multiprocessing only",      RTEMS_PROXY_BLOCKING, },
     { "could not get enough memory",        RTEMS_NO_MEMORY, },
+    { "internal multiprocessing only",      THREAD_STATUS_PROXY_BLOCKING, },
     { 0, 0, 0 },
 };
@@ -135,5 +135,5 @@
         local_errno = errno;
 
-    if (_Configuration_Is_multiprocessing())
+    if (_System_state_Is_multiprocessing)
         fprintf(stderr, "[%d] ", _Configuration_MP_table->node);
     
Index: c/src/lib/libmisc/monitor/mon-dname.c
===================================================================
--- c/src/lib/libmisc/monitor/mon-dname.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libmisc/monitor/mon-dname.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -58,5 +58,6 @@
     rtems_driver_name_t    *np = 0;
 
-    for (np = table + n ; n<RTEMS_MAX_DRIVER_NAMES; n++, np++)
+/* XXX should we be using _IO_Number_of_devices */
+    for (np = table + n ; n<_IO_Number_of_devices; n++, np++)
         if (np->device_name)
             goto done;
Index: c/src/lib/libmisc/monitor/mon-extension.c
===================================================================
--- c/src/lib/libmisc/monitor/mon-extension.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libmisc/monitor/mon-extension.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -23,18 +23,18 @@
 
     rtems_monitor_symbol_canonical_by_value(&canonical_extension->create,
-                                            e->rtems_task_create);
+                                            e->thread_create);
 
     rtems_monitor_symbol_canonical_by_value(&canonical_extension->start,
-                                            e->rtems_task_start);
+                                            e->thread_start);
     rtems_monitor_symbol_canonical_by_value(&canonical_extension->restart,
-                                            e->rtems_task_restart);
+                                            e->thread_restart);
     rtems_monitor_symbol_canonical_by_value(&canonical_extension->delete,
-                                            e->rtems_task_delete);
+                                            e->thread_delete);
     rtems_monitor_symbol_canonical_by_value(&canonical_extension->tswitch,
-                                            e->task_switch);
+                                            e->thread_switch);
     rtems_monitor_symbol_canonical_by_value(&canonical_extension->begin,
-                                            e->task_begin);
+                                            e->thread_begin);
     rtems_monitor_symbol_canonical_by_value(&canonical_extension->exitted,
-                                            e->task_exitted);
+                                            e->thread_exitted);
     rtems_monitor_symbol_canonical_by_value(&canonical_extension->fatal,
                                             e->fatal);
Index: c/src/lib/libmisc/monitor/mon-object.c
===================================================================
--- c/src/lib/libmisc/monitor/mon-object.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libmisc/monitor/mon-object.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -93,5 +93,8 @@
     },
     { RTEMS_OBJECT_DNAME,
-      (void *) &rtems_driver_name_table[0],
+      /* XXX now that the driver name table is allocated from the */
+      /* XXX Workspace, this does not work */
+      (void *) 0,
+      /* (void *) _IO_Driver_name_table, */
       sizeof(rtems_monitor_dname_t),
       (rtems_monitor_object_next_fn)        rtems_monitor_dname_next,
Index: c/src/lib/libmisc/monitor/mon-server.c
===================================================================
--- c/src/lib/libmisc/monitor/mon-server.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libmisc/monitor/mon-server.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -220,5 +220,5 @@
     rtems_status_code status;
     
-    if (_Configuration_Is_multiprocessing()    &&
+    if (_System_state_Is_multiprocessing    &&
         (_Configuration_MP_table->maximum_nodes > 1))
     {
Index: c/src/lib/libmisc/monitor/mon-task.c
===================================================================
--- c/src/lib/libmisc/monitor/mon-task.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libmisc/monitor/mon-task.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -20,4 +20,7 @@
 {
     Thread_Control       *rtems_thread = (Thread_Control *) thread_void;
+    RTEMS_API_Control    *api;
+
+    api = rtems_thread->API_Extensions[ THREAD_API_RTEMS ];
     
     canonical_task->entry = rtems_thread->Start.entry_point;
@@ -28,9 +31,16 @@
     canonical_task->state = rtems_thread->current_state;
     canonical_task->wait_id = rtems_thread->Wait.id;
-    canonical_task->events = rtems_thread->RTEMS_API->pending_events;
-    canonical_task->modes = rtems_thread->current_modes;
-    canonical_task->attributes = 0 /* XXX FIX ME rtems_thread->RTEMS_API->attribute_set */;
-    (void) memcpy(canonical_task->notepad, rtems_thread->RTEMS_API->Notepads, sizeof(canonical_task->notepad));
+    canonical_task->events = api->pending_events;
+
+/* XXX modes and attributes only exist in the RTEMS API .. */
+/* XXX not directly in the core thread.. they will have to be derived */
+/* XXX if they are important enough to include anymore.   */
+    canonical_task->modes = 0; /* XXX FIX ME.... rtems_thread->current_modes; */
+    canonical_task->attributes = 0 /* XXX FIX ME rtems_thread->API_Extensions[ THREAD_API_RTEMS ]->attribute_set */;
+    (void) memcpy(canonical_task->notepad, api ->Notepads, sizeof(canonical_task->notepad));
+/* XXX more to fix */
+/*
     (void) memcpy(&canonical_task->wait_args, &rtems_thread->Wait.Extra, sizeof(canonical_task->wait_args));
+*/
 }
 
Index: c/src/lib/libmisc/stackchk/check.c
===================================================================
--- c/src/lib/libmisc/stackchk/check.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libmisc/stackchk/check.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -19,16 +19,7 @@
  */
 
-#include <rtems/system.h>
-#include <rtems/extension.h>
-#include <rtems/fatal.h>
-#include <rtems/heap.h>
-#include <rtems/stack.h>
-#include <rtems/thread.h>
-#ifdef XXX_RTEMS_H_FIXED
-#include <bsp.h>
-#else
-#include <rtems/config.h>
+#include <rtems.h>
+
 extern rtems_configuration_table BSP_Configuration;
-#endif
 
 #include <assert.h>
@@ -57,4 +48,5 @@
   0,                                /* rtems_task_delete  */
   Stack_check_Switch_extension,     /* task_switch  */
+  0,                                /* task_post_switch  */
   Stack_check_Begin_extension,      /* task_begin   */
   0,                                /* task_exitted */
@@ -134,7 +126,11 @@
 void Stack_check_Initialize( void )
 {
-  rtems_status_code status;
-  Objects_Id   id_ignored;
-  unsigned32  *p;
+  rtems_status_code    status;
+  Objects_Id           id_ignored;
+  unsigned32          *p;
+  unsigned32           i;
+  unsigned32           class_index;
+  Thread_Control      *the_thread;
+  Objects_Information *information;
 
   if (stack_check_initialized)
@@ -172,8 +168,29 @@
    */
 
+  /* XXX
+   *
+   *  Technically this has not been done for any task created before this
+   *  happened.  So just run through them and fix the situation.
+   */
+#if 0
   if (_Thread_Executing)
   {
       Stack_check_Create_extension(_Thread_Executing, _Thread_Executing);
   }
+#endif
+
+#if 0
+  for ( class_index = OBJECTS_CLASSES_FIRST ;
+        class_index <= OBJECTS_CLASSES_LAST ;
+        class_index++ ) {
+    information = _Objects_Information_table[ class_index ];
+    if ( information && information->is_thread ) {
+      for ( i=1 ; i <= information->maximum ; i++ ) {
+        the_thread = (Thread_Control *)information->local_table[ i ];
+        Stack_check_Create_extension( the_thread, the_thread );
+      }
+    }
+  }
+#endif
 
   /*
@@ -198,11 +215,13 @@
  */
 
-void Stack_check_Create_extension(
+boolean Stack_check_Create_extension(
   Thread_Control *running,
   Thread_Control *the_thread
 )
 {
-    if (the_thread && (the_thread != _Thread_Executing))
+    if (the_thread /* XXX && (the_thread != _Thread_Executing) */ )
         stack_check_dope_stack(&the_thread->Start.Initial_stack);
+
+    return TRUE;
 }
 
Index: c/src/lib/libmisc/stackchk/internal.h
===================================================================
--- c/src/lib/libmisc/stackchk/internal.h	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libmisc/stackchk/internal.h	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -51,5 +51,5 @@
  */
 
-void Stack_check_Create_extension(
+boolean Stack_check_Create_extension(
   Thread_Control *running,
   Thread_Control *the_thread
Index: c/src/lib/start/i960/start.s
===================================================================
--- c/src/lib/start/i960/start.s	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/start/i960/start.s	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -81,5 +81,6 @@
         ldconst 0,g0
         ldconst 0,g1
-        call    _bsp_start
+        ldconst 0,g2
+        call    _main
         ret
 
Index: c/src/lib/start/m68k/start.s
===================================================================
--- c/src/lib/start/m68k/start.s	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/start/m68k/start.s	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -98,5 +98,12 @@
 #endif
 
-        jsr     SYM (bsp_start)
+
+        movel   #0,a7@-               | push environp
+        movel   #0,a7@-               | push argv
+        movel   #0,a7@-               | push argc
+
+        jsr     SYM (main)
+        addl    #12,a7
+
 #if ( M68K_HAS_SEPARATE_STACKS == 1 )
         move.l  SYM (initial_isp),a0
